<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: image_dataset_metadata.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_16c1ed31850e16beb18fa0343646fe8c.html">data_io</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">image_dataset_metadata.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2011  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_IMAGE_DAtASET_METADATA_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_IMAGE_DAtASET_METADATA_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../geometry.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;{</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <span class="keyword">namespace </span>image_dataset_metadata</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    {</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="structdlib_1_1image__dataset__metadata_1_1box.html">   19</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="structdlib_1_1image__dataset__metadata_1_1box.html">box</a></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        {</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="structdlib_1_1image__dataset__metadata_1_1box.html#a4c59a6fe65d8ffb43b4a489dc793fd7d">   31</a></span>&#160;            <a class="code" href="structdlib_1_1image__dataset__metadata_1_1box.html#a4c59a6fe65d8ffb43b4a489dc793fd7d">box</a>(</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            ) : </div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;                difficult(false),</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;                truncated(false),</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;                occluded(false),</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;                ignore(false),</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;                angle(0)</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;            {}</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;            <a class="code" href="structdlib_1_1image__dataset__metadata_1_1box.html#a4c59a6fe65d8ffb43b4a489dc793fd7d">box</a> (</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;                <span class="keyword">const</span> <a class="code" href="classdlib_1_1rectangle.html">rectangle</a>&amp; rect_</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;            ) : </div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;                rect(rect_), </div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;                difficult(false),</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;                truncated(false),</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;                occluded(false),</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                ignore(false),</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;                angle(0)</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;            {}</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;            <a class="code" href="classdlib_1_1rectangle.html">rectangle</a> rect;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;            std::map&lt;std::string,point&gt; parts;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            <span class="comment">// optional fields</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            std::string <a class="code" href="classdlib_1_1label.html">label</a>;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            <span class="keywordtype">bool</span> difficult;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            <span class="keywordtype">bool</span> truncated;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;            <span class="keywordtype">bool</span> occluded;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            <span class="keywordtype">bool</span> ignore;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            <span class="comment">// The angle of the object in radians.  Positive values indicate that the</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            <span class="comment">// object at the center of the box is rotated clockwise by angle radians.  A</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            <span class="comment">// value of 0 would indicate that the object is in its &quot;standard&quot; upright pose.</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;            <span class="comment">// Therefore, to make the object appear upright we would have to rotate the</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            <span class="comment">// image counter-clockwise by angle radians.</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            <span class="keywordtype">double</span> angle; </div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            <span class="keywordtype">bool</span> has_label()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classdlib_1_1label.html">label</a>.size() != 0; }</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        };</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div><div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="structdlib_1_1image__dataset__metadata_1_1image.html">   78</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="structdlib_1_1image__dataset__metadata_1_1image.html">image</a></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        {</div><div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="structdlib_1_1image__dataset__metadata_1_1image.html#a8b4d8521a4b2522b8a1bb63d8d4204c2">   85</a></span>&#160;            <a class="code" href="structdlib_1_1image__dataset__metadata_1_1image.html#a8b4d8521a4b2522b8a1bb63d8d4204c2">image</a>() {}</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;            <a class="code" href="structdlib_1_1image__dataset__metadata_1_1image.html#a8b4d8521a4b2522b8a1bb63d8d4204c2">image</a>(<span class="keyword">const</span> std::string&amp; f) : filename(f) {}</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            std::string filename;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;            std::vector&lt;box&gt; boxes;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        };</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160; </div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div><div class="line"><a name="l00094"></a><span class="lineno"><a class="line" href="structdlib_1_1image__dataset__metadata_1_1dataset.html">   94</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="structdlib_1_1image__dataset__metadata_1_1dataset.html">dataset</a></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        {</div><div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="structdlib_1_1image__dataset__metadata_1_1dataset.html#a4031d6f98c770fb53b0a7b661eda496f">  102</a></span>&#160;            std::vector&lt;image&gt; <a class="code" href="structdlib_1_1image__dataset__metadata_1_1dataset.html#a4031d6f98c770fb53b0a7b661eda496f">images</a>;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;            std::string comment;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            std::string name;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        };</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160; </div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <span class="keywordtype">void</span> save_image_dataset_metadata (</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            <span class="keyword">const</span> <a class="code" href="structdlib_1_1image__dataset__metadata_1_1dataset.html">dataset</a>&amp; meta,</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            <span class="keyword">const</span> std::string&amp; filename</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        );</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160; </div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="keywordtype">void</span> load_image_dataset_metadata (</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            <a class="code" href="structdlib_1_1image__dataset__metadata_1_1dataset.html">dataset</a>&amp; meta,</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            <span class="keyword">const</span> std::string&amp; filename</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        );</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    }</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;}</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160; </div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="preprocessor">#ifdef NO_MAKEFILE</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="preprocessor">#include &quot;image_dataset_metadata.cpp&quot;</span></div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="preprocessor">#endif // DLIB_IMAGE_DAtASET_METADATA_Hh_</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="astructdlib_1_1image__dataset__metadata_1_1dataset_html"><div class="ttname"><a href="structdlib_1_1image__dataset__metadata_1_1dataset.html">dlib::image_dataset_metadata::dataset</a></div><div class="ttdef"><b>Definition:</b> image_dataset_metadata.h:94</div></div>
<div class="ttc" id="astructdlib_1_1image__dataset__metadata_1_1image_html_a8b4d8521a4b2522b8a1bb63d8d4204c2"><div class="ttname"><a href="structdlib_1_1image__dataset__metadata_1_1image.html#a8b4d8521a4b2522b8a1bb63d8d4204c2">dlib::image_dataset_metadata::image::image</a></div><div class="ttdeci">image()</div><div class="ttdef"><b>Definition:</b> image_dataset_metadata.h:85</div></div>
<div class="ttc" id="astructdlib_1_1image__dataset__metadata_1_1dataset_html_a4031d6f98c770fb53b0a7b661eda496f"><div class="ttname"><a href="structdlib_1_1image__dataset__metadata_1_1dataset.html#a4031d6f98c770fb53b0a7b661eda496f">dlib::image_dataset_metadata::dataset::images</a></div><div class="ttdeci">std::vector&lt; image &gt; images</div><div class="ttdef"><b>Definition:</b> image_dataset_metadata.h:102</div></div>
<div class="ttc" id="astructdlib_1_1image__dataset__metadata_1_1image_html"><div class="ttname"><a href="structdlib_1_1image__dataset__metadata_1_1image.html">dlib::image_dataset_metadata::image</a></div><div class="ttdef"><b>Definition:</b> image_dataset_metadata.h:78</div></div>
<div class="ttc" id="astructdlib_1_1image__dataset__metadata_1_1box_html_a4c59a6fe65d8ffb43b4a489dc793fd7d"><div class="ttname"><a href="structdlib_1_1image__dataset__metadata_1_1box.html#a4c59a6fe65d8ffb43b4a489dc793fd7d">dlib::image_dataset_metadata::box::box</a></div><div class="ttdeci">box()</div><div class="ttdef"><b>Definition:</b> image_dataset_metadata.h:31</div></div>
<div class="ttc" id="astructdlib_1_1image__dataset__metadata_1_1box_html"><div class="ttname"><a href="structdlib_1_1image__dataset__metadata_1_1box.html">dlib::image_dataset_metadata::box</a></div><div class="ttdef"><b>Definition:</b> image_dataset_metadata.h:19</div></div>
<div class="ttc" id="aclassdlib_1_1rectangle_html"><div class="ttname"><a href="classdlib_1_1rectangle.html">dlib::rectangle</a></div><div class="ttdef"><b>Definition:</b> rectangle.h:19</div></div>
<div class="ttc" id="aclassdlib_1_1label_html"><div class="ttname"><a href="classdlib_1_1label.html">dlib::label</a></div><div class="ttdef"><b>Definition:</b> widgets.h:52</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
